<!-- This file is generated by scripts/link-docs.mjs. Do not edit manually. -->

# Tinymist Maintainers


Tinymist [ˈtaɪni mɪst] is an integrated language service for [Typst](https://typst.app/) [taɪpst].

This page is generated from [./MAINTAINERS.typ](./MAINTAINERS.typ) and renders information of [maintainers](#maintainers) and [features.](#features)

## Maintainers

- [**Myriad-Dreamin**](https://github.com/Myriad-Dreamin)
  - Email: camiyoru@gmail.com
  - Maintains: *[Editor Integration](#editor-integration)*, *[Language Service](#language-service)*, *[Document Previewing](#document-previewing)*, *[VS Code Client-Side Support](#vs-code-client-side-support)*, and *[Nightly Releases](#nightly-releases)*

- [**Enter-tainer**](https://github.com/Enter-tainer)
  - Email: mgt@oi-wiki.org
  - Maintains: *[Editor Integration](#editor-integration)*, *[Language Service](#language-service)*, *[Document Previewing](#document-previewing)*, and *[VS Code Client-Side Support](#vs-code-client-side-support)*

- [**ParaN3xus**](https://github.com/ParaN3xus)
  - Email: paran3xus007@gmail.com
  - Maintains: *[Nightly Releases](#nightly-releases)*

- [**Max397**](https://github.com/max397574)
  - Email: undefined
  - Maintains: *[Editor Integration](#editor-integration)*

- [**Ericoolen**](https://github.com/Eric-Song-Nop)
  - Email: EricYFSong@gmail.com
  - Maintains: *[Language Service](#language-service)*

- [**Caleb Maclennan**](https://github.com/alerque)
  - Email: caleb@alerque.com
  - Maintains: *[Editor Integration](#editor-integration)*

- [**SylvanFranklin**](https://github.com/SylvanFranklin)
  - Email: sylvanfranklin@icloud.com
  - Maintains: *[Editor Integration](#editor-integration)*, and *[Document Previewing](#document-previewing)*

## Features

### Editor Integration
 Integrate tinymist server with popular editors like VS Code, Neovim, etc. 
- Scope: [`crates/tinymist/`](./crates/tinymist/), [`editors/`](./editors/)
### Language Service
 Perform code analysis and provide language support for Typst. 
- Scope: [`crates/tinymist/`](./crates/tinymist/), [`crates/tinymist-analysis/`](./crates/tinymist-analysis/), [`crates/tinymist-query/`](./crates/tinymist-query/)
### Document Previewing
 Provide instant preview of the document being edited. 
- Scope: [`crates/tinymist/`](./crates/tinymist/), [`crates/typst-preview/`](./crates/typst-preview/), [`contrib/typst-preview/`](./contrib/typst-preview/), [`tools/typst-dom/`](./tools/typst-dom/), [`tools/typst-preview-frontend/`](./tools/typst-preview-frontend/)
### VS Code Client-Side Support
 Enrich the VS Code features with the client-side extension. 
- Scope: [`crates/tinymist/`](./crates/tinymist/), [`editors/vscode/`](./editors/vscode/), [`tools/editor-tools/`](./tools/editor-tools/)
### Nightly Releases
 Build and Publish nightly releases of tinymist. The nightly releases are built upon the main branches of both tinymist and typst. 
- Scope: [`crates/tinymist/`](./crates/tinymist/), [`crates/typst-shim/`](./crates/typst-shim/)